%!octave 
%      
%     EM
%       
%       OS : GNU/Linux 3.9.3-1-ARCH 
% COMPILER : GNU Octave, version 3.6.4
%
%   AUTHOR : Evgeny S. Borisov
%
%  Glushkov Institute of Cybernetics
%  National Academy of Sciences of Ukraine
% 
%    http://www.mechanoid.kiev.ua
%  e-mail : nn@mechanoid.kiev.ua
% 

% - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

%points1 = load('data/points_7.txt');
%X = [ points1 ] ;


points1 = load('data/points_5.txt');
X = [ points1(:,1)*0.1 points1(:,2)*0.01 ] ;

m = size(X,1)  % количество точек
n = size(X,2) ; % размер вектора

k = 2 ; % количество компонент смеси распределения

% - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
% начальные значения параметров

% матрица ковариаций и априорная вероятность 
S0 = cov(X) ; S = S0 ;
for j=2:k, S = [ S S0 ]; endfor;
w0 = 1/k; w = ones(1,k)*w0 ;
% случайный вектор мат.ожидание
mu = [ mean(X) ; rand(k-1,n) ] ;
mu0 = mu ;

plotMix( X,S,mu,sprintf('result/points_%i_step_00.png',k),'init' ) ;

% - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

[ S, mu, w, gmax ] = em_base(X,S,mu,w,k) ;

% - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
save('-text','result/mu.txt', 'mu' ) ;
save('-text','result/w.txt', 'w' ) ;
save('-text','result/s.txt', 'S' ) ;



clf ; 
plot(gmax(:,1),gmax(:,2),'-r') ; 
mingmax = min(gmax(:,2)) ; 
t = sprintf("k = %i, iter = %i,\n error = %f", k, size(gmax,1), mingmax ) ;
title(t) ;
print(sprintf('result/gmax_%i.png',k),'-dpng' ,'-S650,650') ;


% $Id: main.m,v 1.5 2013/12/21 11:04:07 mechanoid Exp mechanoid $
