%!octave
%      
%       
%       OS : GNU/Linux 3.9.3-1-ARCH 
% COMPILER : GNU Octave, version 3.6.4
%
%   AUTHOR : Evgeny S. Borisov
%
%  Glushkov Institute of Cybernetics
%  National Academy of Sciences of Ukraine
% 
%    http://www.mechanoid.kiev.ua
%  e-mail : nn@mechanoid.kiev.ua
% 


function plotMix(X,S,mu,file,titl)
   ang=0:0.1:2*pi ;
   circ = [ cos(ang)' sin(ang)' ];
   circ = [ circ ; circ(1,:) ];

   n=size(X,2);
   k=size(S,2)/n;

   clf ; hold on ;
%   axis([ 0 0.8 0 1.3 ]);
   title(titl) ;
   plot( X(:,1) , X(:,2) , '.b' ) ; 
   plot( mu(:,1) , mu(:,2) , '.r' ) ; 

   for j=1:k,
	  s1 = j*n-(n-1); s2=s1+(n-1);
	  s = S(:,s1:s2) ;
	  scale = 1/( 2*pi*sqrt( det(s) ) );
	  [ v, l ] = eig( s ) ;
	  v = v.*sum(l,2) ;
	  el = circ*v * scale + mu(j,:)  ;
	  plot( el(:,1) , el(:,2) , '-r' ) ; 
   endfor;
   print(file,'-dpng' ,'-S650,650') ;
endfunction;


% $Id: plotMix.m,v 1.1 2013/12/21 11:04:07 mechanoid Exp mechanoid $
